Loading...
Searching...
No Matches
Ogre::RenderSystem Class Referenceabstract
Core » RenderSystem

Defines the functionality of a 3D API. More...

`#include <OgreRenderSystem.h>`

Inheritance diagram for Ogre::RenderSystem:
[legend]

## Classes

class | Listener
| Defines a listener on the custom events that this render system can raise. More...

## Public Member Functions

| RenderSystem ()
| Default Constructor.
virtual | ~RenderSystem ()
| Destructor.
virtual void | _beginFrame ()
| Signifies the beginning of a frame, i.e.
void | _beginGeometryCount (void)
| The RenderSystem will keep a count of tris rendered, this resets the count.
void | _cleanupDepthBuffers (bool bCleanManualBuffers=true)
| Removes all depth buffers.
virtual void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, bool forGpuProgram=false)=0
| Converts a uniform projection matrix to suitable for this render system.
virtual DepthBuffer * | _createDepthBufferFor (RenderTarget *renderTarget)=0
| Creates a DepthBuffer that can be attached to the specified RenderTarget.
virtual RenderWindow * | _createRenderWindow (const String &name, unsigned int width, unsigned int height, bool fullScreen, const NameValuePairList *miscParams=0)
| Creates a new rendering window.
virtual void | _disableTextureUnit (size_t texUnit)
| Turns off a texture unit.
virtual void | _disableTextureUnitsFrom (size_t texUnit)
| Disables all texture units from the given unit upwards.
virtual void | _dispatchCompute (const Vector3i &workgroupDim)
virtual void | _endFrame (void)=0
| Ends rendering of a frame to the current viewport.
unsigned int | _getBatchCount (void) const
| Reports the number of batches rendered since the last _beginGeometryCount call.
virtual CullingMode | _getCullingMode (void) const
const String & | _getDefaultViewportMaterialScheme (void) const
| Returns the default material scheme used by the render system.
unsigned int | _getFaceCount (void) const
| Reports the number of tris rendered since the last _beginGeometryCount call.
unsigned int | _getVertexCount (void) const
| Reports the number of vertices passed to the renderer since the last _beginGeometryCount call.
virtual Viewport * | _getViewport (void)
| Get the current active viewport for rendering.
virtual void | _initialise ()
| Start up the renderer using the settings selected (Or the defaults if none have been selected).
void | _initRenderTargets (void)
| Utility method for initialising all render targets attached to this rendering system.
void | _notifyCameraRemoved (const Camera *cam)
| Utility method to notify all render targets that a camera has been removed, in case they were referring to it as their viewer.
virtual void | _render (const RenderOperation &op)
| Render something to the active viewport.
virtual void | _setAlphaRejectSettings (CompareFunction func, unsigned char value, bool alphaToCoverage)=0
| Sets the global alpha rejection approach for future renders.
void | _setColourBufferWriteEnabled (bool red, bool green, bool blue, bool alpha)
virtual void | _setCullingMode (CullingMode mode)=0
| Sets the culling mode for the render system based on the 'vertex winding'.
virtual void | _setDepthBias (float constantBias, float slopeScaleBias=0.0f)=0
| Sets the depth bias, NB you should use the Material version of this.
virtual void | _setDepthBufferParams (bool depthTest=true, bool depthWrite=true, CompareFunction depthFunction=CMPF_LESS_EQUAL)=0
| Sets the mode of operation for depth buffer tests from this point onwards.
virtual void | _setDepthClamp (bool enable)
| Clamp depth values to near and far plane rather than discarding.
void | _setFog (FogMode f)
virtual void | _setLineWidth (float width)
| Set the line width when drawing as RenderOperation::OT_LINE_LIST/ RenderOperation::OT_LINE_STRIP.
virtual void | _setPointParameters (bool attenuationEnabled, Real minSize, Real maxSize)
virtual void | _setPointSpritesEnabled (bool enabled)
| Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.
virtual void | _setPolygonMode (PolygonMode level)=0
| Sets how to rasterise triangles, as points, wireframe or solid polys.
void | _setProjectionMatrix (Matrix4 m)
virtual void | _setRenderTarget (RenderTarget *target)=0
| Set current render target to target, enabling its device context if needed.
virtual void | _setSampler (size_t texUnit, Sampler &s)=0
| set the sampler settings for the given texture unit
void | _setSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendOperation op=SBO_ADD)
void | _setSeparateSceneBlending (SceneBlendFactor sourceFactor, SceneBlendFactor destFactor, SceneBlendFactor sourceFactorAlpha, SceneBlendFactor destFactorAlpha, SceneBlendOperation op=SBO_ADD, SceneBlendOperation alphaOp=SBO_ADD)
virtual void | _setTexture (size_t unit, bool enabled, const TexturePtr &texPtr)=0
| Sets the texture to bind to a given texture unit.
virtual void | _setTextureBlendMode (size_t unit, const LayerBlendModeEx &bm)
| Sets the texture blend modes from a TextureUnitState record.
virtual void | _setTextureCoordCalculation (size_t unit, TexCoordCalcMethod m, const Frustum *frustum=0)
| Sets a method for automatically calculating texture coordinates for a stage.
virtual void | _setTextureCoordSet (size_t unit, size_t index)
| Sets the texture coordinate set to use for a texture unit.
virtual void | _setTextureMatrix (size_t unit, const Matrix4 &xform)
| Sets the texture coordinate transformation matrix for a texture unit.
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin.
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once.
void | _setViewMatrix (const Matrix4 &m)
virtual void | _setViewport (Viewport *vp)=0
| Sets the provided viewport as the active one for future rendering operations.
void | _setWorldMatrix (const Matrix4 &m)
virtual void | _swapAllRenderTargetBuffers ()
| Internal method for swapping all the buffers on all render targets, if _updateAllRenderTargets was called with a 'false' parameter.
virtual void | _updateAllRenderTargets (bool swapBuffers=true)
| Internal method for updating all render targets attached to this rendering system.
virtual void | _useLights (unsigned short limit)
| Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).
void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise.
virtual void | applyFixedFunctionParams (const GpuProgramParametersPtr &params, uint16 variabilityMask)
void | attachRenderTarget (RenderTarget &target)
| Attaches the passed render target to the render system.
virtual void | beginProfileEvent (const String &eventName)=0
| This marks the beginning of an event for GPU profiling.
virtual void | bindGpuProgram (GpuProgram *prg)
| Binds a given GpuProgram (but not the parameters).
virtual void | bindGpuProgramParameters (GpuProgramType gptype, const GpuProgramParametersPtr &params, uint16 variabilityMask)=0
| Bind Gpu program parameters.
virtual void | clearFrameBuffer (uint32 buffers, const ColourValue &colour=ColourValue::Black, float depth=1.0f, uint16 stencil=0)=0
| Clears one or more frame buffers on the active render target.
virtual HardwareOcclusionQuery * | createHardwareOcclusionQuery (void)=0
| Create an object for performing hardware occlusion queries.
virtual MultiRenderTarget * | createMultiRenderTarget (const String &name)=0
| Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object.
virtual void | destroyRenderTarget (const String &name)
| Destroys a render target of any sort.
virtual void | destroyRenderTexture (const String &name)
| Destroys a render texture.
virtual void | destroyRenderWindow (const String &name)
| Destroys a render window.
virtual RenderTarget * | detachRenderTarget (const String &name)
| Detaches the render target with the passed name from the render system and returns a pointer to it.
void | disableSchemeInstancing (const String &materialScheme)
| disables instancing for the given material scheme
void | enableSchemeInstancing (const String &materialScheme, const HardwareVertexBufferPtr &buffer, VertexDeclaration *decl, uint32 instanceCount)
| Sets the global instance data for the given material scheme.
virtual void | endProfileEvent (void)=0
| Ends the currently active GPU profiling event.
const RenderSystemCapabilities * | getCapabilities (void) const
| Gets the capabilities of the render system.
const ConfigOptionMap & | getConfigOptions () const
| Returns the details of this API's configuration options.
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
const DriverVersion & | getDriverVersion (void) const
| Returns the driver version.
virtual const GpuProgramParametersPtr & | getFixedFunctionParams (TrackVertexColourType tracking, FogMode fog)
uint32 | getGlobalInstanceCount () const
HardwareVertexBufferPtr | getGlobalInstanceVertexBuffer () const
VertexDeclaration * | getGlobalInstanceVertexDeclaration () const
virtual Real | getHorizontalTexelOffset (void)
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.
bool | getInvertVertexWinding (void) const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g.
virtual Real | getMaximumDepthInputValue (void)=0
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms.
virtual Real | getMinimumDepthInputValue (void)=0
| Gets the minimum (closest) depth value to be used when rendering using identity transforms.
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem.
virtual const String & | getName (void) const =0
| Returns the name of the rendering system.
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system.
const StringVector & | getRenderSystemEvents (void) const
| Gets a list of the rendersystem specific events that this rendersystem can raise.
RenderTarget * | getRenderTarget (const String &name)
| Returns a pointer to the render target with the passed name, or NULL if that render target cannot be found.
RenderWindowDescription | getRenderWindowDescription () const
| get a RenderWindowDescription from the current ConfigOptionMap
GlobalInstancingData | getSchemeInstancingData (const String &materialScheme) const
| Gets all data for the global scheme based instancing.
virtual Real | getVerticalTexelOffset (void)
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.
bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound.
bool | isReverseDepthBufferEnabled () const
| Returns if reverse Z-buffer is enabled.
virtual void | markProfileEvent (const String &event)=0
| Marks an instantaneous event for graphics profilers.
virtual void | postExtraThreadsStarted ()
| Tell the rendersystem to perform any tasks it needs to directly after other threads which might access the rendering API are registered.
virtual void | preExtraThreadsStarted ()
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.
virtual void | registerThread ()
| Register the an additional thread which may make calls to rendersystem-related objects.
void | reinitialise (void)
| Restart the renderer (normally following a change in settings).
void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise.
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region.
virtual void | setColourBlendState (const ColourBlendState &state)=0
| Sets the global blending factors for combining subsequent renders with the existing frame contents.
virtual void | setConfigOption (const String &name, const String &value)=0
| Sets an option for this API.
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value.
void | setDepthBufferFor (RenderTarget *renderTarget)
| Retrieves an existing DepthBuffer or creates a new one suited for the given RenderTarget and sets it.
void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.
virtual bool | setDrawBuffer (ColourBufferType colourBuffer)
| Sets the colour buffer that the render system will to draw.
void | setGlobalInstanceCount (uint32 val)
void | setGlobalInstanceVertexBuffer (const HardwareVertexBufferPtr &val)
void | setGlobalInstanceVertexDeclaration (VertexDeclaration *val)
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.
virtual void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled.
virtual void | setNormaliseNormals (bool normalise)
| Sets whether or not normals are to be automatically normalised.
virtual void | setScissorTest (bool enabled, const Rect &rect=Rect())=0
| Sets the 'scissor region' i.e.
void | setScissorTest (bool enabled, uint32 left, uint32 top=0, uint32 right=800, uint32 bottom=600)
virtual void | setShadingType (ShadeOptions so)
| Sets the type of light shading required (default = Gouraud).
void | setStencilBufferParams (CompareFunction func=CMPF_ALWAYS_PASS, uint32 refValue=0, uint32 compareMask=0xFFFFFFFF, uint32 writeMask=0xFFFFFFFF, StencilOperation stencilFailOp=SOP_KEEP, StencilOperation depthFailOp=SOP_KEEP, StencilOperation passOp=SOP_KEEP, bool twoSidedOperation=false)
void | setStencilCheckEnabled (bool enabled)
virtual void | setStencilState (const StencilState &state)=0
| This method allows you to set all the stencil buffer parameters in one call.
virtual void | shutdown (void)
| Shutdown the renderer and cleanup resources.
virtual void | unbindGpuProgram (GpuProgramType gptype)
| Unbinds GpuPrograms of a given GpuProgramType.
virtual void | unregisterThread ()
| Unregister an additional thread which may make calls to rendersystem-related objects.
void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities.
virtual String | validateConfigOptions (void)
| Validates the options set for the rendering system, returning a message if there are problems.

## Static Public Member Functions

static void | convertColourValue (const ColourValue &colour, uint32 *pDest)
static VertexElementType | getColourVertexElementType (void)
static Listener * | getSharedListener (void)
| Retrieve a pointer to the current shared render system listener.
static void | setSharedListener (Listener *listener)
| Sets shared listener.

## Detailed Description

Defines the functionality of a 3D API.

The RenderSystem class provides a base interface which abstracts the general functionality of the 3D API e.g. Direct3D or OpenGL. Whilst a few of the general methods have implementations, most of this class is abstract, requiring a subclass based on a specific API to be constructed to provide the full functionality. Note there are 2 levels to the interface - one which will be used often by the caller of the Ogre library, and one which is at a lower level and will be used by the other classes provided by Ogre. These lower level methods are prefixed with '_' to differentiate them. The advanced user of the library may use these lower level methods to access the 3D API at a more fundamental level (dealing direct with render states and rendering primitives), but still benefiting from Ogre's abstraction of exactly which 3D API is in use.

Author
  Steven Streeting

## Constructor & Destructor Documentation

## RenderSystem()

Ogre::RenderSystem::RenderSystem | ( |  | ) |

Default Constructor.

## ~RenderSystem()

virtual Ogre::RenderSystem::~RenderSystem | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## getName()

virtual const String & Ogre::RenderSystem::getName | ( | void |  | ) | const

pure virtual

Returns the name of the rendering system.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## getConfigOptions()

const ConfigOptionMap & Ogre::RenderSystem::getConfigOptions | ( |  | ) | const

inline

Returns the details of this API's configuration options.

Each render system must be able to inform the world of what options must/can be specified for it's operation.

  These are passed as strings for portability, but grouped into a structure (ConfigOption) which includes both options and current value.

  Note that the settings returned from this call are affected by the options that have been set so far, since some options are interdependent.

  This routine is called automatically by the default configuration dialogue produced by Root::showConfigDialog or may be used by the caller for custom settings dialogs

Returns
  A 'map' of options, i.e. a list of options which is also indexed by option name.

## setConfigOption()

virtual void Ogre::RenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value )

pure virtual

Sets an option for this API.

Used to confirm the settings (normally chosen by the user) in order to make the renderer able to initialise with the settings as required. This may initialise the RenderWindowDescription or set some RenderSystem specific parameters. Called automatically by the default configuration dialog, and by the restoration of saved settings. These settings are stored and only activated when RenderSystem::_initialise or RenderSystem::reinitialise are called.

If using a custom configuration dialog, it is advised that the caller calls RenderSystem::getConfigOptions again, since some options can alter resulting from a selection.

Common options:

Key | Default | Description
--- | --- | ---
Full Screen | false | Window full-screen flag
VSync | true | "vsync" in _createRenderWindow
VSync Interval | 1 | "vsyncInterval" in _createRenderWindow
sRGB Gamma Conversion | false | "gamma" in _createRenderWindow
FSAA | 0 | concatenation of "FSAA" and "FSAAHint" as in _createRenderWindow
Video Mode | - | Window resolution
Display Frequency | - | "displayFrequency" in _createRenderWindow
Content Scaling Factor | 1.0 | "contentScalingFactor" in _createRenderWindow

Parameters

  name | The name of the option to alter.
  value | The value to set the option to.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## getRenderWindowDescription()

RenderWindowDescription Ogre::RenderSystem::getRenderWindowDescription | ( |  | ) | const

get a RenderWindowDescription from the current ConfigOptionMap

## createHardwareOcclusionQuery()

virtual HardwareOcclusionQuery * Ogre::RenderSystem::createHardwareOcclusionQuery | ( | void |  | ) |

pure virtual

Create an object for performing hardware occlusion queries.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## destroyHardwareOcclusionQuery()

virtual void Ogre::RenderSystem::destroyHardwareOcclusionQuery | ( | HardwareOcclusionQuery * | hq | ) |

virtual

Destroy a hardware occlusion query object.

## validateConfigOptions()

virtual String Ogre::RenderSystem::validateConfigOptions | ( | void |  | ) |

inline virtual

Validates the options set for the rendering system, returning a message if there are problems.

Note
  If the returned string is empty, there are no problems.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

References Ogre::BLANKSTRING.

## _initialise()

virtual void Ogre::RenderSystem::_initialise | ( |  | ) |

virtual

Start up the renderer using the settings selected (Or the defaults if none have been selected).

Called by Root::setRenderSystem. Shouldn't really be called directly, although this can be done if the app wants to.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

## getMutableCapabilities()

RenderSystemCapabilities * Ogre::RenderSystem::getMutableCapabilities | ( |  | ) |

inline

Get a pointer to the current capabilities being used by the RenderSystem.

The capabilities may be modified using this pointer, this will only have an effect before the RenderSystem has been initialised. It's intended use is to allow a listener of the RenderSystemCapabilitiesCreated event to customise the capabilities on the fly before the RenderSystem is initialised.

## useCustomRenderSystemCapabilities()

void Ogre::RenderSystem::useCustomRenderSystemCapabilities | ( | RenderSystemCapabilities * | capabilities | ) |

Force the render system to use the special capabilities.

Can only be called before the render system has been fully initializer (before createWindow is called)

Parameters

  capabilities | has to be a subset of the real capabilities and the caller is responsible for deallocating capabilities.

## reinitialise()

void Ogre::RenderSystem::reinitialise | ( | void |  | ) |

Restart the renderer (normally following a change in settings).

## shutdown()

virtual void Ogre::RenderSystem::shutdown | ( | void |  | ) |

virtual

Shutdown the renderer and cleanup resources.

Reimplemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## getFixedFunctionParams()

virtual const GpuProgramParametersPtr & Ogre::RenderSystem::getFixedFunctionParams | ( | TrackVertexColourType | tracking,
|  | FogMode | fog )

inline virtual

Reimplemented in Ogre::D3D9RenderSystem, and Ogre::MetalRenderSystem.

Referenced by _setFog().

## _setProjectionMatrix()

void Ogre::RenderSystem::_setProjectionMatrix | ( | Matrix4 | m | ) |

Deprecated
  migrate to getFixedFunctionParams ASAP. this is very slow now.

## _setViewMatrix()

void Ogre::RenderSystem::_setViewMatrix | ( | const Matrix4 & | m | ) |

inline

Deprecated
  migrate to getFixedFunctionParams ASAP. this is very slow now.

References applyFixedFunctionParams(), and Ogre::GPV_GLOBAL.

## _setWorldMatrix()

void Ogre::RenderSystem::_setWorldMatrix | ( | const Matrix4 & | m | ) |

inline

Deprecated
  migrate to getFixedFunctionParams ASAP. this is very slow now.

References applyFixedFunctionParams(), and Ogre::GPV_PER_OBJECT.

## _setFog()

void Ogre::RenderSystem::_setFog | ( | FogMode | f | ) |

inline

Deprecated
  migrate to getFixedFunctionParams ASAP. this is very slow now.

References getFixedFunctionParams(), and Ogre::TVC_NONE.

## _setSceneBlending()

void Ogre::RenderSystem::_setSceneBlending | ( | SceneBlendFactor | sourceFactor,
|  | SceneBlendFactor | destFactor,
|  | SceneBlendOperation | op = SBO_ADD )

inline

Deprecated
  use setColourBlendState

References Ogre::SBO_ADD, and setColourBlendState().

## applyFixedFunctionParams()

virtual void Ogre::RenderSystem::applyFixedFunctionParams | ( | const GpuProgramParametersPtr & | params,
|  | uint16 | variabilityMask )

inline virtual

Reimplemented in Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, and Ogre::TinyRenderSystem.

Referenced by _setViewMatrix(), and _setWorldMatrix().

## setShadingType()

virtual void Ogre::RenderSystem::setShadingType | ( | ShadeOptions | so | ) |

inline virtual

Sets the type of light shading required (default = Gouraud).

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## setLightingEnabled()

virtual void Ogre::RenderSystem::setLightingEnabled | ( | bool | enabled | ) |

inline virtual

Sets whether or not dynamic lighting is enabled.

Parameters

  enabled | If true, dynamic lighting is performed on geometry with normals supplied, geometry without normals will not be displayed. If false, no lighting is applied and all geometry will be full brightness.

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem, and Ogre::TinyRenderSystem.

## _createRenderWindow()

virtual RenderWindow * Ogre::RenderSystem::_createRenderWindow | ( | const String & | name,
|  | unsigned int | width,
|  | unsigned int | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = 0 )

virtual

Creates a new rendering window.

This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:

Key | Type / Values | Default | Description | Platform
--- | --- | --- | --- | ---
title | String | RenderTarget name | The title of the window that will appear in the title bar |
left | Positive integers | Centred | Screen x coordinate from left |
top | Positive integers | Centred | Screen y coordinate from left |
hidden | true, false | false | hide the created window |
FSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor |
gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
Full Screen | true, false | false | Specify whether to create the window in full screen mode |
border | none, fixed, resize | resize | The type of window border (in windowed mode) | Windows, OSX
displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |

externalWindowHandle

- Win32: HWND as int
- Linux: X11 Window as ulong
- OSX: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually
- iOS: UIWindow address as an integer
- Emscripten: canvas selector String ("#canvas")

0 (none)

External window handle, for embedding the OGRE render in an existing window

externalGLControl

true, false

false

Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls.

OpenGL

externalWlDisplay | wl_display address as an integer | 0 (none) | Wayland display connection | Linux
externalWlSurface | wl_surface address as an integer | 0 (none) | Wayland onscreen surface | Linux
currentGLContext | true, false | false | Use an externally created GL context. (Must be current) | OpenGL
currentEGLSurface | true, false | false | Use an externally created EGL surface. | Android
minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min total colour buffer size. See EGL_BUFFER_SIZE | OpenGL
windowProc | WNDPROC | DefWindowProc | function that processes window messages | Win 32
colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32
FSAAHint | RenderSystem specific. Currently enables EQAA/ CSAA mode on D3D: if you want 4f8x (8x CSAA), set FSAA=4 and this to "f8" | Blank | FSAA mode hint | D3D
outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area | Win32
monitorIndex |  | -1 |  | Win 32
monitorHandle |  | 0 (none) |  | Win 32 (OpenGL)
enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32
useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD | D3D
depthBuffer | true, false | true | Use depth buffer | D3D
NSOpenGLCPSurfaceOrder | -1 or 1 | 1 | NSOpenGLCPSurfaceOrder | OSX

contentScalingFactor

Positive Float

The default content scaling factor of the screen

On IOS specifies the CAEAGLLayer content scaling factor. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor.

OSX, iOS, Android

externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS
externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS
externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS
CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor | Android
maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android
maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android
maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android

Reimplemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, and Ogre::TinyRenderSystem.

## createMultiRenderTarget()

virtual MultiRenderTarget * Ogre::RenderSystem::createMultiRenderTarget | ( | const String & | name | ) |

pure virtual

Create a MultiRenderTarget, which is a render target that renders to multiple RenderTextures at once.

Surfaces can be bound and unbound at will. This fails if mCapabilities->getNumMultiRenderTargets() is smaller than 2.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## destroyRenderWindow()

virtual void Ogre::RenderSystem::destroyRenderWindow | ( | const String & | name | ) |

virtual

Destroys a render window.

## destroyRenderTexture()

virtual void Ogre::RenderSystem::destroyRenderTexture | ( | const String & | name | ) |

virtual

Destroys a render texture.

## destroyRenderTarget()

virtual void Ogre::RenderSystem::destroyRenderTarget | ( | const String & | name | ) |

virtual

Destroys a render target of any sort.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

## attachRenderTarget()

void Ogre::RenderSystem::attachRenderTarget | ( | RenderTarget & | target | ) |

Attaches the passed render target to the render system.

## getRenderTarget()

RenderTarget * Ogre::RenderSystem::getRenderTarget | ( | const String & | name | ) |

Returns a pointer to the render target with the passed name, or NULL if that render target cannot be found.

## detachRenderTarget()

virtual RenderTarget * Ogre::RenderSystem::detachRenderTarget | ( | const String & | name | ) |

virtual

Detaches the render target with the passed name from the render system and returns a pointer to it.

Note
  If the render target cannot be found, NULL is returned.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

## getGlobalInstanceVertexBuffer()

HardwareVertexBufferPtr Ogre::RenderSystem::getGlobalInstanceVertexBuffer | ( |  | ) | const

inline

Deprecated
  use getSchemeInstancingData instead

References _getDefaultViewportMaterialScheme().

## setGlobalInstanceVertexBuffer()

void Ogre::RenderSystem::setGlobalInstanceVertexBuffer | ( | const HardwareVertexBufferPtr & | val | ) |

Deprecated
  use enableSchemeInstancing instead

## getGlobalInstanceVertexDeclaration()

VertexDeclaration * Ogre::RenderSystem::getGlobalInstanceVertexDeclaration | ( |  | ) | const

inline

Deprecated
  use getSchemeInstancingData instead

References _getDefaultViewportMaterialScheme().

## setGlobalInstanceVertexDeclaration()

void Ogre::RenderSystem::setGlobalInstanceVertexDeclaration | ( | VertexDeclaration * | val | ) |

inline

Deprecated
  use enableSchemeInstancing instead

References _getDefaultViewportMaterialScheme().

## getGlobalInstanceCount()

uint32 Ogre::RenderSystem::getGlobalInstanceCount | ( |  | ) | const

inline

Deprecated
  use getSchemeInstancingData instead

References _getDefaultViewportMaterialScheme().

## setGlobalInstanceCount()

void Ogre::RenderSystem::setGlobalInstanceCount | ( | uint32 | val | ) |

inline

Deprecated
  use enableSchemeInstancing instead

References _getDefaultViewportMaterialScheme().

## enableSchemeInstancing()

void Ogre::RenderSystem::enableSchemeInstancing | ( | const String & | materialScheme,
|  | const HardwareVertexBufferPtr & | buffer,
|  | VertexDeclaration * | decl,
|  | uint32 | instanceCount )

Sets the global instance data for the given material scheme.

## getSchemeInstancingData()

GlobalInstancingData Ogre::RenderSystem::getSchemeInstancingData | ( | const String & | materialScheme | ) | const

inline

Gets all data for the global scheme based instancing.

## disableSchemeInstancing()

void Ogre::RenderSystem::disableSchemeInstancing | ( | const String & | materialScheme | ) |

inline

disables instancing for the given material scheme

## setDepthBufferFor()

void Ogre::RenderSystem::setDepthBufferFor | ( | RenderTarget * | renderTarget | ) |

Retrieves an existing DepthBuffer or creates a new one suited for the given RenderTarget and sets it.

RenderTarget's pool ID is respected.

See also
  RenderTarget::setDepthBufferPool()

## isReverseDepthBufferEnabled()

bool Ogre::RenderSystem::isReverseDepthBufferEnabled | ( |  | ) | const

Returns if reverse Z-buffer is enabled.

If you have large scenes and need big far clip distance but still want to draw objects closer (for example cockpit of a plane) you can enable reverse depth buffer so that the depth buffer precision is greater further away. This enables the OGRE_REVERSED_Z preprocessor define for shaders.

Return values

  true | If reverse Z-buffer is enabled.
  false | If reverse Z-buffer is disabled (default).

See also
  setReverseDepthBuffer

## _useLights()

virtual void Ogre::RenderSystem::_useLights | ( | unsigned short | limit | ) |

inline virtual

Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setTextureUnitSettings()

virtual void Ogre::RenderSystem::_setTextureUnitSettings | ( | size_t | texUnit,
|  | TextureUnitState & | tl )

virtual

Utility function for setting all the properties of a texture unit at once.

This method is also worth using over the individual texture unit settings because it only sets those settings which are different from the current settings for this unit, thus minimising render state changes.

## _setSampler()

virtual void Ogre::RenderSystem::_setSampler | ( | size_t | texUnit,
|  | Sampler & | s )

pure virtual

set the sampler settings for the given texture unit

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _disableTextureUnit()

virtual void Ogre::RenderSystem::_disableTextureUnit | ( | size_t | texUnit | ) |

virtual

Turns off a texture unit.

## _disableTextureUnitsFrom()

virtual void Ogre::RenderSystem::_disableTextureUnitsFrom | ( | size_t | texUnit | ) |

virtual

Disables all texture units from the given unit upwards.

## _setPointSpritesEnabled()

virtual void Ogre::RenderSystem::_setPointSpritesEnabled | ( | bool | enabled | ) |

inline virtual

Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.

Parameters

  enabled | True enables point sprites, false returns to normal point rendering.

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setPointParameters()

virtual void Ogre::RenderSystem::_setPointParameters | ( | bool | attenuationEnabled,
|  | Real | minSize,
|  | Real | maxSize )

inline virtual

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setLineWidth()

virtual void Ogre::RenderSystem::_setLineWidth | ( | float | width | ) |

inline virtual

Set the line width when drawing as RenderOperation::OT_LINE_LIST/ RenderOperation::OT_LINE_STRIP.

Parameters

  width | only value of 1.0 might be supported. Check for RSC_WIDE_LINES.

## _setTexture()

virtual void Ogre::RenderSystem::_setTexture | ( | size_t | unit,
|  | bool | enabled,
|  | const TexturePtr & | texPtr )

pure virtual

Sets the texture to bind to a given texture unit.

User processes would not normally call this direct unless rendering primitives themselves.

Parameters

  unit | The index of the texture unit to modify. Multitexturing hardware can support multiple units (see RenderSystemCapabilites::getNumTextureUnits)
  enabled | Boolean to turn the unit on/off
  texPtr | Pointer to the texture to use.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _setTextureCoordSet()

virtual void Ogre::RenderSystem::_setTextureCoordSet | ( | size_t | unit,
|  | size_t | index )

inline virtual

Sets the texture coordinate set to use for a texture unit.

Meant for use internally - not generally used directly by apps - the Material and TextureUnitState classes let you manage textures far more easily.

Parameters

  unit | Texture unit as above
  index | The index of the texture coordinate set to use.

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setTextureCoordCalculation()

virtual void Ogre::RenderSystem::_setTextureCoordCalculation | ( | size_t | unit,
|  | TexCoordCalcMethod | m,
|  | const Frustum * | frustum = 0 )

inline virtual

Sets a method for automatically calculating texture coordinates for a stage.

Should not be used by apps - for use by Ogre only.

Parameters

  unit | Texture unit as above
  m | Calculation method to use
  frustum | Optional Frustum param, only used for projective effects

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setTextureBlendMode()

virtual void Ogre::RenderSystem::_setTextureBlendMode | ( | size_t | unit,
|  | const LayerBlendModeEx & | bm )

inline virtual

Sets the texture blend modes from a TextureUnitState record.

Meant for use internally only - apps should use the Material and TextureUnitState classes.

Parameters

  unit | Texture unit as above
  bm | Details of the blending mode

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _setTextureMatrix()

virtual void Ogre::RenderSystem::_setTextureMatrix | ( | size_t | unit,
|  | const Matrix4 & | xform )

inline virtual

Sets the texture coordinate transformation matrix for a texture unit.

Parameters

  unit | Texture unit to affect
  xform | The 4x4 matrix

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## setColourBlendState()

virtual void Ogre::RenderSystem::setColourBlendState | ( | const ColourBlendState & | state | ) |

pure virtual

Sets the global blending factors for combining subsequent renders with the existing frame contents.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

Referenced by _setColourBufferWriteEnabled(), _setSceneBlending(), and _setSeparateSceneBlending().

## _setSeparateSceneBlending()

void Ogre::RenderSystem::_setSeparateSceneBlending | ( | SceneBlendFactor | sourceFactor,
|  | SceneBlendFactor | destFactor,
|  | SceneBlendFactor | sourceFactorAlpha,
|  | SceneBlendFactor | destFactorAlpha,
|  | SceneBlendOperation | op = SBO_ADD,
|  | SceneBlendOperation | alphaOp = SBO_ADD )

inline

Deprecated
  use setColourBlendState

References Ogre::SBO_ADD, and setColourBlendState().

## _setAlphaRejectSettings()

virtual void Ogre::RenderSystem::_setAlphaRejectSettings | ( | CompareFunction | func,
|  | unsigned char | value,
|  | bool | alphaToCoverage )

pure virtual

Sets the global alpha rejection approach for future renders.

By default images are rendered regardless of texture alpha. This method lets you change that.

Parameters

  func | The comparison function which must pass for a pixel to be written.
  value | The value to compare each pixels alpha value to (0-255)
  alphaToCoverage | Whether to enable alpha to coverage, if supported

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _setTextureProjectionRelativeTo()

virtual void Ogre::RenderSystem::_setTextureProjectionRelativeTo | ( | bool | enabled,
|  | const Vector3 & | pos )

virtual

Notify the rendersystem that it should adjust texture projection to be relative to a different origin.

## _createDepthBufferFor()

virtual DepthBuffer * Ogre::RenderSystem::_createDepthBufferFor | ( | RenderTarget * | renderTarget | ) |

pure virtual

Creates a DepthBuffer that can be attached to the specified RenderTarget.

It doesn't attach anything, it just returns a pointer to a new DepthBuffer Caller is responsible for putting this buffer into the right pool, for attaching, and deleting it. Here's where API-specific magic happens. Don't call this directly unless you know what you're doing.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _cleanupDepthBuffers()

void Ogre::RenderSystem::_cleanupDepthBuffers | ( | bool | bCleanManualBuffers = true | ) |

Removes all depth buffers.

Should be called on device lost and shutdown

Advanced users can call this directly with bCleanManualBuffers=false to remove all depth buffers created for RTTs; when they think the pool has grown too big or they've used lots of depth buffers they don't need anymore, freeing GPU RAM.

Referenced by Ogre::D3D9RenderSystem::_addManualDepthBuffer().

## _beginFrame()

virtual void Ogre::RenderSystem::_beginFrame | ( |  | ) |

virtual

Signifies the beginning of a frame, i.e.

the start of rendering on a single viewport. Will occur several times per complete frame if multiple viewports exist.

Reimplemented in Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, and Ogre::VulkanRenderSystem.

## _endFrame()

virtual void Ogre::RenderSystem::_endFrame | ( | void |  | ) |

pure virtual

Ends rendering of a frame to the current viewport.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _setViewport()

virtual void Ogre::RenderSystem::_setViewport | ( | Viewport * | vp | ) |

pure virtual

Sets the provided viewport as the active one for future rendering operations.

This viewport is aware of it's own camera and render target. Must be implemented by subclass.

Parameters

  vp | Pointer to the appropriate viewport.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _getViewport()

virtual Viewport * Ogre::RenderSystem::_getViewport | ( | void |  | ) |

virtual

Get the current active viewport for rendering.

## _setCullingMode()

virtual void Ogre::RenderSystem::_setCullingMode | ( | CullingMode | mode | ) |

pure virtual

Sets the culling mode for the render system based on the 'vertex winding'.

A typical way for the rendering engine to cull triangles is based on the 'vertex winding' of triangles. Vertex winding refers to the direction in which the vertices are passed or indexed to in the rendering operation as viewed from the camera, and will either be clockwise or anticlockwise (that's 'counterclockwise' for you Americans out there ;) The default is Ogre::CULL_CLOCKWISE i.e. that only triangles whose vertices are passed/indexed in anticlockwise order are rendered - this is a common approach and is used in 3D studio models for example. You can alter this culling mode if you wish but it is not advised unless you know what you are doing.

You may wish to use the Ogre::CULL_NONE option for mesh data that you cull yourself where the vertex winding is uncertain or for creating 2-sided passes.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _getCullingMode()

virtual CullingMode Ogre::RenderSystem::_getCullingMode | ( | void |  | ) | const

virtual

## _setDepthBufferParams()

virtual void Ogre::RenderSystem::_setDepthBufferParams | ( | bool | depthTest = true,
|  | bool | depthWrite = true,
|  | CompareFunction | depthFunction = CMPF_LESS_EQUAL )

pure virtual

Sets the mode of operation for depth buffer tests from this point onwards.

Sometimes you may wish to alter the behaviour of the depth buffer to achieve special effects. Because it's unlikely that you'll set these options for an entire frame, but rather use them to tweak settings between rendering objects, this is an internal method (indicated by the '_' prefix) which will be used by a SceneManager implementation rather than directly from the client application. If this method is never called the settings are automatically the same as the default parameters.

Parameters

  depthTest | If true, the depth buffer is tested for each pixel and the frame buffer is only updated if the depth function test succeeds. If false, no test is performed and pixels are always written.
  depthWrite | If true, the depth buffer is updated with the depth of the new pixel if the depth test succeeds. If false, the depth buffer is left unchanged even if a new pixel is written.
  depthFunction | Sets the function required for the depth test.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

References Ogre::CMPF_LESS_EQUAL.

## _setColourBufferWriteEnabled()

void Ogre::RenderSystem::_setColourBufferWriteEnabled | ( | bool | red,
|  | bool | green,
|  | bool | blue,
|  | bool | alpha )

inline

Deprecated
  use setColourBlendState

References setColourBlendState().

## _setDepthBias()

virtual void Ogre::RenderSystem::_setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias = 0.0f )

pure virtual

Sets the depth bias, NB you should use the Material version of this.

When polygons are coplanar, you can get problems with 'depth fighting' where the pixels from the two polys compete for the same screen pixel. This is particularly a problem for decals (polys attached to another surface to represent details such as bulletholes etc.).

  A way to combat this problem is to use a depth bias to adjust the depth buffer value used for the decal such that it is slightly higher than the true value, ensuring that the decal appears on top.

Note
  The final bias value is a combination of a constant bias and a bias proportional to the maximum depth slope of the polygon being rendered. The final bias is constantBias + slopeScaleBias * maxslope. Slope scale biasing is generally preferable but is not available on older hardware.

Parameters

  constantBias | The constant bias value, expressed as a value in homogeneous depth coordinates.
  slopeScaleBias | The bias value which is factored by the maximum slope of the polygon, see the description above. This is not supported by all cards.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _setDepthClamp()

virtual void Ogre::RenderSystem::_setDepthClamp | ( | bool | enable | ) |

inline virtual

Clamp depth values to near and far plane rather than discarding.

Useful for "shadow caster pancaking" or with shadow volumes

Reimplemented in Ogre::D3D11RenderSystem, Ogre::MetalRenderSystem, and Ogre::VulkanRenderSystem.

## _beginGeometryCount()

void Ogre::RenderSystem::_beginGeometryCount | ( | void |  | ) |

The RenderSystem will keep a count of tris rendered, this resets the count.

## _getFaceCount()

unsigned int Ogre::RenderSystem::_getFaceCount | ( | void |  | ) | const

inline

Reports the number of tris rendered since the last _beginGeometryCount call.

## _getBatchCount()

unsigned int Ogre::RenderSystem::_getBatchCount | ( | void |  | ) | const

inline

Reports the number of batches rendered since the last _beginGeometryCount call.

## _getVertexCount()

unsigned int Ogre::RenderSystem::_getVertexCount | ( | void |  | ) | const

inline

Reports the number of vertices passed to the renderer since the last _beginGeometryCount call.

## convertColourValue()

void Ogre::RenderSystem::convertColourValue | ( | const ColourValue & | colour,
|  | uint32 * | pDest )

inline static

Deprecated
  use ColourValue::getAsBYTE()

References Ogre::ColourValue::getAsBYTE().

## getColourVertexElementType()

VertexElementType Ogre::RenderSystem::getColourVertexElementType | ( | void |  | ) |

inline static

Deprecated
  assume VET_UBYTE4_NORM

References Ogre::VET_UBYTE4_NORM.

## _convertProjectionMatrix()

virtual void Ogre::RenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest,
|  | bool | forGpuProgram = false )

pure virtual

Converts a uniform projection matrix to suitable for this render system.

Because different APIs have different requirements (some incompatible) for the projection matrix, this method allows each to implement their own correctly and pass back a generic OGRE matrix for storage in the engine.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _setPolygonMode()

virtual void Ogre::RenderSystem::_setPolygonMode | ( | PolygonMode | level | ) |

pure virtual

Sets how to rasterise triangles, as points, wireframe or solid polys.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## setStencilState()

virtual void Ogre::RenderSystem::setStencilState | ( | const StencilState & | state | ) |

pure virtual

This method allows you to set all the stencil buffer parameters in one call.

Unlike other render states, stencilling is left for the application to turn on and off when it requires. This is because you are likely to want to change parameters between batches of arbitrary objects and control the ordering yourself. In order to batch things this way, you'll want to use OGRE's Compositor stencil pass or separate render queue groups and register a RenderQueueListener to get notifications between batches.

See also
  RenderQueue

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## setStencilCheckEnabled()

void Ogre::RenderSystem::setStencilCheckEnabled | ( | bool | enabled | ) |

Deprecated
  use setStencilState

## setStencilBufferParams()

void Ogre::RenderSystem::setStencilBufferParams | ( | CompareFunction | func = CMPF_ALWAYS_PASS,
|  | uint32 | refValue = 0,
|  | uint32 | compareMask = 0xFFFFFFFF,
|  | uint32 | writeMask = 0xFFFFFFFF,
|  | StencilOperation | stencilFailOp = SOP_KEEP,
|  | StencilOperation | depthFailOp = SOP_KEEP,
|  | StencilOperation | passOp = SOP_KEEP,
|  | bool | twoSidedOperation = false )

Deprecated
  use setStencilState

References Ogre::CMPF_ALWAYS_PASS, and Ogre::SOP_KEEP.

## setNormaliseNormals()

virtual void Ogre::RenderSystem::setNormaliseNormals | ( | bool | normalise | ) |

inline virtual

Sets whether or not normals are to be automatically normalised.

This is useful when, for example, you are scaling SceneNodes such that normals may not be unit-length anymore. Note though that this has an overhead so should not be turn on unless you really need it.

  You should not normally call this direct unless you are rendering world geometry; set it on the Renderable because otherwise it will be overridden by material settings.

Deprecated
  only needed for fixed function APIs

Reimplemented in Ogre::D3D9RenderSystem.

## _render()

virtual void Ogre::RenderSystem::_render | ( | const RenderOperation & | op | ) |

virtual

Render something to the active viewport.

Low-level rendering interface to perform rendering operations. Unlikely to be used directly by client applications, since the SceneManager and various support classes will be responsible for calling this method. Can only be called between _beginScene and _endScene

Parameters

  op | A rendering operation instance, which contains details of the operation to be performed.

Reimplemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## _dispatchCompute()

virtual void Ogre::RenderSystem::_dispatchCompute | ( | const Vector3i & | workgroupDim | ) |

inline virtual

Reimplemented in Ogre::D3D11RenderSystem.

## getCapabilities()

const RenderSystemCapabilities * Ogre::RenderSystem::getCapabilities | ( | void |  | ) | const

inline

Gets the capabilities of the render system.

## getDriverVersion()

const DriverVersion & Ogre::RenderSystem::getDriverVersion | ( | void |  | ) | const

inline

Returns the driver version.

## _getDefaultViewportMaterialScheme()

const String & Ogre::RenderSystem::_getDefaultViewportMaterialScheme | ( | void |  | ) | const

Returns the default material scheme used by the render system.

Systems that use the RTSS to emulate a fixed function pipeline (e.g. OpenGL ES 2, GL3+, DX11) need to return the default material scheme of the RTSS ShaderGenerator.

This is currently only used to set the default material scheme for viewports. It is a necessary step on these render systems for render textures to be rendered into properly.

Referenced by getGlobalInstanceCount(), getGlobalInstanceVertexBuffer(), getGlobalInstanceVertexDeclaration(), setGlobalInstanceCount(), and setGlobalInstanceVertexDeclaration().

## bindGpuProgram()

virtual void Ogre::RenderSystem::bindGpuProgram | ( | GpuProgram * | prg | ) |

virtual

Binds a given GpuProgram (but not the parameters).

Remarks
  Only one GpuProgram of each type can be bound at once, binding another one will simply replace the existing one.

Reimplemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, and Ogre::VulkanRenderSystem.

## bindGpuProgramParameters()

virtual void Ogre::RenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | const GpuProgramParametersPtr & | params,
|  | uint16 | variabilityMask )

pure virtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## unbindGpuProgram()

virtual void Ogre::RenderSystem::unbindGpuProgram | ( | GpuProgramType | gptype | ) |

virtual

Unbinds GpuPrograms of a given GpuProgramType.

This returns the pipeline to fixed-function processing for this type.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

## isGpuProgramBound()

bool Ogre::RenderSystem::isGpuProgramBound | ( | GpuProgramType | gptype | ) |

Returns whether or not a Gpu program of the given type is currently bound.

## getNativeShadingLanguageVersion()

uint16 Ogre::RenderSystem::getNativeShadingLanguageVersion | ( |  | ) | const

inline

Gets the native shading language version for this render system.

Formatted so that it can be used within a shading program. For example, OpenGL 3.2 would return 150, while 3.3 would return 330

## setClipPlanes()

virtual void Ogre::RenderSystem::setClipPlanes | ( | const PlaneList & | clipPlanes | ) |

virtual

Sets the user clipping region.

Deprecated
  only needed for fixed function APIs

## _initRenderTargets()

void Ogre::RenderSystem::_initRenderTargets | ( | void |  | ) |

Utility method for initialising all render targets attached to this rendering system.

## _notifyCameraRemoved()

void Ogre::RenderSystem::_notifyCameraRemoved | ( | const Camera * | cam | ) |

Utility method to notify all render targets that a camera has been removed, in case they were referring to it as their viewer.

## _updateAllRenderTargets()

virtual void Ogre::RenderSystem::_updateAllRenderTargets | ( | bool | swapBuffers = true | ) |

virtual

Internal method for updating all render targets attached to this rendering system.

Reimplemented in Ogre::D3D11RenderSystem.

## _swapAllRenderTargetBuffers()

virtual void Ogre::RenderSystem::_swapAllRenderTargetBuffers | ( |  | ) |

virtual

Internal method for swapping all the buffers on all render targets, if _updateAllRenderTargets was called with a 'false' parameter.

Reimplemented in Ogre::D3D11RenderSystem.

## setInvertVertexWinding()

void Ogre::RenderSystem::setInvertVertexWinding | ( | bool | invert | ) |

Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.

## getInvertVertexWinding()

bool Ogre::RenderSystem::getInvertVertexWinding | ( | void |  | ) | const

Indicates whether or not the vertex windings set will be inverted for the current render (e.g.

reflections)

See also
  RenderSystem::setInvertVertexWinding

## setScissorTest() [1/2]

virtual void Ogre::RenderSystem::setScissorTest | ( | bool | enabled,
|  | const Rect & | rect = Rect() )

pure virtual

Sets the 'scissor region' i.e.

the region of the target in which rendering can take place.

This method allows you to 'mask off' rendering in all but a given rectangular area as identified by the parameters to this method.

Parameters

  enabled | True to enable the scissor test, false to disable it.
  rect | The location of the corners of the rectangle, expressed in pixels.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

Referenced by setScissorTest().

## setScissorTest() [2/2]

void Ogre::RenderSystem::setScissorTest | ( | bool | enabled,
|  | uint32 | left,
|  | uint32 | top = 0,
|  | uint32 | right = 800,
|  | uint32 | bottom = 600 )

inline

Deprecated

References setScissorTest().

## clearFrameBuffer()

virtual void Ogre::RenderSystem::clearFrameBuffer | ( | uint32 | buffers,
|  | const ColourValue & | colour = ColourValue::Black,
|  | float | depth = 1.0f,
|  | uint16 | stencil = 0 )

pure virtual

Clears one or more frame buffers on the active render target.

Parameters

  buffers | Combination of one or more elements of FrameBufferType denoting which buffers are to be cleared
  colour | The colour to clear the colour buffer with, if enabled
  depth | The value to initialise the depth buffer with, if enabled
  stencil | The value to initialise the stencil buffer with, if enabled.

References Ogre::ColourValue::Black.

## getHorizontalTexelOffset()

virtual Real Ogre::RenderSystem::getHorizontalTexelOffset | ( | void |  | ) |

inline virtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Note
  only non-zero with D3D9

Reimplemented in Ogre::D3D9RenderSystem, and Ogre::VulkanRenderSystem.

## getVerticalTexelOffset()

virtual Real Ogre::RenderSystem::getVerticalTexelOffset | ( | void |  | ) |

inline virtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Note
  only non-zero with D3D9

Reimplemented in Ogre::D3D9RenderSystem, and Ogre::VulkanRenderSystem.

## getMinimumDepthInputValue()

virtual Real Ogre::RenderSystem::getMinimumDepthInputValue | ( | void |  | ) |

pure virtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## getMaximumDepthInputValue()

virtual Real Ogre::RenderSystem::getMaximumDepthInputValue | ( | void |  | ) |

pure virtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## setCurrentPassIterationCount()

virtual void Ogre::RenderSystem::setCurrentPassIterationCount | ( | const size_t | count | ) |

inline virtual

set the current multi pass count value.

This must be set prior to calling _render() if multiple renderings of the same pass state are required.

Parameters

  count | Number of times to render the current state.

## setDeriveDepthBias()

void Ogre::RenderSystem::setDeriveDepthBias | ( | bool | derive,
|  | float | baseValue = 0.0f,
|  | float | multiplier = 0.0f,
|  | float | slopeScale = 0.0f )

inline

Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.

The depth bias set will be baseValue + iteration * multiplier

Parameters

  derive | True to tell the RS to derive this automatically
  baseValue | The base value to which the multiplier should be added
  multiplier | The amount of depth bias to apply per iteration
  slopeScale | The constant slope scale bias for completeness

## _setRenderTarget()

virtual void Ogre::RenderSystem::_setRenderTarget | ( | RenderTarget * | target | ) |

pure virtual

Set current render target to target, enabling its device context if needed.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## setSharedListener()

void Ogre::RenderSystem::setSharedListener | ( | Listener * | listener | ) |

static

Sets shared listener.

Shared listener could be set even if no render system is selected yet. This listener will receive "RenderSystemChanged" event on each Root::setRenderSystem call.

## getSharedListener()

Listener * Ogre::RenderSystem::getSharedListener | ( | void |  | ) |

static

Retrieve a pointer to the current shared render system listener.

## addListener()

void Ogre::RenderSystem::addListener | ( | Listener * | l | ) |

Adds a listener to the custom events that this render system can raise.

Some render systems have quite specific, internally generated events that the application may wish to be notified of. Many applications don't have to worry about these events, and can just trust OGRE to handle them, but if you want to know, you can add a listener here.

  Events are raised very generically by string name. Perhaps the most common example of a render system specific event is the loss and restoration of a device in DirectX; which OGRE deals with, but you may wish to know when it happens.

See also
  RenderSystem::getRenderSystemEvents

## removeListener()

void Ogre::RenderSystem::removeListener | ( | Listener * | l | ) |

Remove a listener to the custom events that this render system can raise.

## getRenderSystemEvents()

const StringVector & Ogre::RenderSystem::getRenderSystemEvents | ( | void |  | ) | const

inline

Gets a list of the rendersystem specific events that this rendersystem can raise.

See also
  RenderSystem::addListener

## preExtraThreadsStarted()

virtual void Ogre::RenderSystem::preExtraThreadsStarted | ( |  | ) |

inline virtual

Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.

Call this from your main thread before starting your other threads.

Note
  If you start your own threads, there is a specific startup sequence which must be respected and requires synchronisation between the threads:
  1. [Main thread] Call preExtraThreadsStarted()
  2. [Main thread] Start other thread, wait
  3. [Other thread] Call registerThread(), notify main thread & continue
  4. [Main thread] Wake up & call postExtraThreadsStarted()
  Once this init sequence is completed the threads are independent but this startup sequence must be respected.

## postExtraThreadsStarted()

virtual void Ogre::RenderSystem::postExtraThreadsStarted | ( |  | ) |

inline virtual

Tell the rendersystem to perform any tasks it needs to directly after other threads which might access the rendering API are registered.

See also
  RenderSystem::preExtraThreadsStarted

## registerThread()

virtual void Ogre::RenderSystem::registerThread | ( |  | ) |

inline virtual

Register the an additional thread which may make calls to rendersystem-related objects.

This method should only be called by additional threads during their initialisation. If they intend to use hardware rendering system resources they should call this method before doing anything related to the render system. Some rendering APIs require a per-thread setup and this method will sort that out. It is also necessary to call unregisterThread before the thread shuts down.

Note
  This method takes no parameters - it must be called from the thread being registered and that context is enough.

## unregisterThread()

virtual void Ogre::RenderSystem::unregisterThread | ( |  | ) |

inline virtual

Unregister an additional thread which may make calls to rendersystem-related objects.

See also
  RenderSystem::registerThread

## beginProfileEvent()

virtual void Ogre::RenderSystem::beginProfileEvent | ( | const String & | eventName | ) |

pure virtual

This marks the beginning of an event for GPU profiling.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## endProfileEvent()

virtual void Ogre::RenderSystem::endProfileEvent | ( | void |  | ) |

pure virtual

Ends the currently active GPU profiling event.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## markProfileEvent()

virtual void Ogre::RenderSystem::markProfileEvent | ( | const String & | event | ) |

pure virtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling

See also
  beginProfileEvent and
  endProfileEvent back to back.

Implemented in Ogre::D3D11RenderSystem, Ogre::D3D9RenderSystem, Ogre::MetalRenderSystem, Ogre::TinyRenderSystem, and Ogre::VulkanRenderSystem.

## getCustomAttribute()

virtual void Ogre::RenderSystem::getCustomAttribute | ( | const String & | name,
|  | void * | pData )

virtual

Gets a custom (maybe platform-specific) attribute.

Remarks
  This is a nasty way of satisfying any API's need to see platform-specific details.

Parameters

  name | The name of the attribute.
  pData | Pointer to memory of the right kind of structure to receive the info.

Reimplemented in Ogre::D3D11RenderSystem.

## setDrawBuffer()

virtual bool Ogre::RenderSystem::setDrawBuffer | ( | ColourBufferType | colourBuffer | ) |

inline virtual

Sets the colour buffer that the render system will to draw.

If the render system implementation or configuration does not support a particular value, then false will be returned and the current colour buffer value will not be modified.

Parameters

  colourBuffer | Specifies the colour buffer that will be drawn into.

Reimplemented in Ogre::D3D11RenderSystem, and Ogre::D3D9RenderSystem.

The documentation for this class was generated from the following file:

- OgreRenderSystem.h